from machine import Pin, I2C, Timer
import ssd1306
import urequests
import time
import _thread
import network
import ujson
import sys

def connect_wifi():
    wlan = network.WLAN(network.STA_IF)
    if not wlan.active():
        wlan.active(True)

    if not wlan.isconnected():
        wlan.connect('my_wifi', 'password')
        while not wlan.isconnected():
            time.sleep(1)
    print(wlan.ifconfig())

connect_wifi()


def play_pressed(timer):
    response = urequests.post('http://homecenter-backend.herokuapp.com/status/playing')

def play_debounce(pin):
    # Start or replace a timer for 200ms, and trigger on_pressed.
    timer.init(mode=Timer.ONE_SHOT, period=200, callback=play_pressed)

def pause_pressed(timer):
    response = urequests.post('http://homecenter-backend.herokuapp.com/status/pause')

def pause_debounce(pin):
    # Start or replace a timer for 200ms, and trigger on_pressed.
    timer.init(mode=Timer.ONE_SHOT, period=200, callback=pause_pressed)

def stop_pressed(timer):
    response = urequests.post('http://homecenter-backend.herokuapp.com/status/stop')

def pause_debounce(pin):
    # Start or replace a timer for 200ms, and trigger on_pressed.
    timer.init(mode=Timer.ONE_SHOT, period=200, callback=stop_pressed)

# Register a new hardware timer.
timer = Timer(0)

# Setup the button input pin with a pull-up resistor.
play = Pin(0, Pin.IN, Pin.PULL_UP)
pause = Pin(4, Pin.IN, Pin.PULL_UP)
exit = Pin(32, Pin.IN, Pin.PULL_UP)


# Register an interrupt on rising button input.
play.irq(play_debounce, Pin.IRQ_RISING)
stop.irq(stop_debounce, Pin.IRQ_RISING)
pause.irq(pause_debounce, Pin.IRQ_RISING)