from machine import Pin, I2C
import ssd1306
import urequests
import time
import _thread
import network
import ujson
import sys

def connect_wifi():
    wlan = network.WLAN(network.STA_IF)
    if not wlan.active():
        wlan.active(True)

    if not wlan.isconnected():
        wlan.connect('my_wifi', 'password')
        while not wlan.isconnected():
            time.sleep(1)
    print(wlan.ifconfig())

connect_wifi()

 
response = urequests.get('http://homecenter-backend.herokuapp.com/status')
parsed = response[0].json()
play   = parsed["isPlaying"]
stop   = parsed["isStoping"]
finish = parsed["isFinished"]
songname = parsed["SongName"]

def get_game_state():
  global play
  global stop
  global finish
  global songname
  while True:
    response = urequests.get('http://homecenter-backend.herokuapp.com/status')
    parsed = response[0].json()
    play   = parsed["isPlaying"]
    stop   = parsed["isStoping"]
    finish = parsed["isFinished"]
    songname = parsed["SongName"]
    time.sleep(2)
 
_thread.start_new_thread(testThread, ())

# ESP32 Pin assignment 
i2c = I2C(0, scl=Pin(22), sda=Pin(21))

oled_width = 128
oled_height = 64
oled = ssd1306.SSD1306_I2C(oled_width, oled_height, i2c)

while(1):
    if (stop == 1):
      oled.fill(0)
      oled.text('HomeCenter', 0, 0)
    elif (finish == 1):
      response = urequests.get('http://homecenter-backend.herokuapp.com/score')
      parsed = response[0].json()
      score   = parsed["Score"]
      mention   = parsed["Mention"]
      oled.fill(0)
      oled.text(score, 0, 0)
      oled.text(mention, 0, 16)
    elif (play == 1):
      oled.fill(0)
      oled.text('Playing', 0, 0)
      oled.text(songname, 0, 16)
    elif (play == 0):
      oled.fill(0)
      oled.text('Pause', 0, 0)
      oled.text(songname, 0, 16)
    oled.show()

