import machine, neopixel
import urequests
import time
import _thread
import network
import ujson
import sys

def connect_wifi():
    wlan = network.WLAN(network.STA_IF)
    if not wlan.active():
        wlan.active(True)

    if not wlan.isconnected():
        wlan.connect('TRUE-HOME_5G', '1001910019')
        while not wlan.isconnected():
            time.sleep(1)
    print(wlan.ifconfig())

connect_wifi()

 
response = urequests.get('http://homecenter-backend.herokuapp.com/status')
parsed = response[0].json()
play   = parsed["isPlaying"]
stop   = parsed["isStoping"]
finish = parsed["isFinished"]

np = neopixel.NeoPixel(machine.Pin(27), 16)
n = np.n

def get_game_state():
  global play
  global stop
  global finish
  while True:
    response = urequests.get('http://homecenter-backend.herokuapp.com/status')
    parsed = response[0].json()
    play   = parsed["isPlaying"]
    stop   = parsed["isStoping"]
    finish = parsed["isFinished"]
    time.sleep(2)
 
_thread.start_new_thread(testThread, ())

def pause_state_led(np):
    # white cycle
    for i in range(4 * n):
        for j in range(n):
            np[j] = (0, 0, 0)
        np[i % n] = (255, 255, 255)
        np.write()
        time.sleep_ms(25)

def play_state_led(np):
    # fade in/out red, green , blue
    for i in range(0, 4 * 256, 8):
        for j in range(n):
            if (i // 256) % 2 == 0:
                val = i & 0xff
            else:
                val = 255 - (i & 0xff)
            np[j] = (val, 0, 0)
        np.write()

    for i in range(0, 4 * 256, 8):
        for j in range(n):
            if (i // 256) % 2 == 0:
                val = i & 0xff
            else:
                val = 255 - (i & 0xff)
            np[j] = (0, val, 0)
        np.write()

    for i in range(0, 4 * 256, 8):
        for j in range(n):
            if (i // 256) % 2 == 0:
                val = i & 0xff
            else:
                val = 255 - (i & 0xff)
            np[j] = (0, 0, val)
        np.write()
    
def stop_state_led(np):
    # clear
    for i in range(n):
        np[i] = (0, 0, 0)
    np.write()

while(1):
    if (stop == 1):
        stop_state_led(np)
    elif (play == 1):
        play_state_led(np)
    else:
        pause_state_led(np)



